%%% File    : streaming_sched1.erl
%%% Author  : Sanchez Penas Juan Jose <juanjo@bulma.lfcia.pri>
%%% Purpose : 
%%% Created : 18 Mar 2002 by Sanchez Penas Juan Jose <juanjo@bulma.lfcia.pri>

-module(users).
-author('juanjo@bulma.lfcia.pri').


-export([start_link/1, init/1]).

start_link(StreamingScheduler) ->
   {ok, spawn_link(?MODULE, init,[StreamingScheduler])}.

init(StreamingScheduler) ->
   loop(StreamingScheduler).

loop(StreamingScheduler) ->   
   io:format("Starting the user loop~n"),
%   receive after 1000 -> ok end,
   {lookupAns, MO, Profile, Options} = 
      gen_server:call(StreamingScheduler,{lookup,m1,[1,2]}),
   case choose(Options) of 
       fail -> 
         loop(StreamingScheduler);
       {Pid, Bw} ->
         gen_server:call(StreamingScheduler,{play, MO, Bw, Pid}),
	 loop(StreamingScheduler)
   end.

choose([]) ->
  fail;
choose([{Bw,Cost,Pid}|Tail]) ->
  minimum(Pid, Bw, Cost,Tail).

% Selected the one with lower cost (not using Bw information

minimum(Selected, Bw, Cost,[]) ->
  {Selected, Bw};
minimum(Selected, Bw1, Cost,[{Bw2,C,Pid}|Tail]) ->
  case Cost =< C of
       true ->
         minimum(Selected, Bw1, Cost,Tail);
      false ->
         minimum(Pid, Bw2, C,Tail)
  end.
