%%%----------------------------------------------------------------------
%%% File    : vodka.erl
%%% Author  : Sanchez Penas Juan Jose <juanjo@bulma.lfcia.pri>
%%% Purpose : 
%%% Created : 3 Jun 2002 by Sanchez Penas Juan Jose <juanjo@bulma.lfcia.pri>
%%%----------------------------------------------------------------------

-module(vodka).
-author('juanjo@lfcia.org').

-behaviour(supervisor).

%% External exports
-export([start_link/1]).

%% supervisor callbacks
-export([init/1]).

%%%----------------------------------------------------------------------
%%% API
%%%----------------------------------------------------------------------
start_link(DeviceList) ->
    supervisor:start_link(?MODULE,DeviceList).

%%%----------------------------------------------------------------------
%%% Callback functions from supervisor
%%%----------------------------------------------------------------------

%%----------------------------------------------------------------------
%% Func: init/1
%% Returns: {ok,  {SupFlags,  [ChildSpec]}} |
%%          ignore                          |
%%          {error, Reason}   
%%----------------------------------------------------------------------
init(DeviceList) ->
    StorageSup = 
      {storage_supervisor,{storage,start_link,
                           [DeviceList]},
                           permanent,2000,supervisor,[]},
    StorageSched =
      {storage_sched,{storage_sched,start_link,[storage_group]},
                    permanent,2000,worker,[]},
    StreamingSched = 
      {streaming_sched,{streaming_sched,start_link,[storage_sched]},
                    permanent,2000,worker, []},
    Users = 
      {user_simulation,{users,start_link,[streaming_sched]},
             permanent,2000,worker,[]},
    {ok,{{one_for_one,0,5000}, 
         [Users,StreamingSched,StorageSched,StorageSup]}}.

%%%----------------------------------------------------------------------
%%% Internal functions
%%%----------------------------------------------------------------------
